import { CorrelationContext } from '../correlation_context/CorrelationContext';
import { SpanContext } from '../trace/span_context';
/** An Instrument for Counter Metric. */
export interface BoundCounter {
    /**
     * Adds the given value to the current value. Values cannot be negative.
     * @param value the value to add.
     */
    add(value: number): void;
}
/** ValueRecorder to report instantaneous measurement of a value. */
export interface BoundValueRecorder {
    /**
     * Records the given value to this value recorder.
     * @param value to record.
     * @param correlationContext the correlationContext associated with the
     *     values.
     * @param spanContext the {@link SpanContext} that identifies the {@link Span}
     *     which the values are associated with.
     */
    record(value: number): void;
    record(value: number, correlationContext: CorrelationContext): void;
    record(value: number, correlationContext: CorrelationContext, spanContext: SpanContext): void;
}
/** An Instrument for Base Observer */
export interface BoundBaseObserver {
    update(value: number): void;
}
//# sourceMappingURL=BoundInstrument.d.ts.map