import { Span } from "@opentelemetry/api";
import { OperationOptions } from "./coreHttp";
/**
 * Configuration for creating a new Tracing Span
 */
export interface SpanConfig {
    /**
     * Package name prefix
     */
    packagePrefix: string;
    /**
     * Service namespace
     */
    namespace: string;
}
/**
 * Creates a function called createSpan to create spans using the global tracer.
 * @hidden
 * @param spanConfig - The name of the operation being performed.
 * @param tracingOptions - The options for the underlying http request.
 */
export declare function createSpanFunction({ packagePrefix, namespace }: SpanConfig): <T extends OperationOptions>(operationName: string, operationOptions: T) => {
    span: Span;
    updatedOptions: T;
};
//# sourceMappingURL=createSpan.d.ts.map