// Copyright (c) Microsoft Corporation.
// Licensed under the MIT license.
import { __awaiter } from "tslib";
import { DefaultScopeSuffix } from "./constants";
export function mapScopesToResource(scopes) {
    let scope = "";
    if (Array.isArray(scopes)) {
        if (scopes.length !== 1) {
            throw new Error("To convert to a resource string the specified array must be exactly length 1");
        }
        scope = scopes[0];
    }
    else if (typeof scopes === "string") {
        scope = scopes;
    }
    if (!scope.endsWith(DefaultScopeSuffix)) {
        return scope;
    }
    return scope.substr(0, scope.lastIndexOf(DefaultScopeSuffix));
}
export function msiGenericGetToken(identityClient, requestOptions, expiresInParser, getTokenOptions = {}) {
    return __awaiter(this, void 0, void 0, function* () {
        const webResource = identityClient.createWebResource(Object.assign({ disableJsonStringifyOnBody: true, deserializationMapper: undefined, abortSignal: getTokenOptions.abortSignal, spanOptions: getTokenOptions.tracingOptions && getTokenOptions.tracingOptions.spanOptions }, requestOptions));
        const tokenResponse = yield identityClient.sendTokenRequest(webResource, expiresInParser);
        return (tokenResponse && tokenResponse.accessToken) || null;
    });
}
//# sourceMappingURL=utils.js.map